diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_user.c ircd-hybrid-6.0/src/s_user.c
--- ircd-hybrid-6.0.orig/src/s_user.c	Fri Jun  8 18:03:40 2001
+++ ircd-hybrid-6.0/src/s_user.c	Fri Jun  8 16:25:06 2001
@@ -47,6 +47,7 @@
 #include "struct.h"
 #include "whowas.h"
 #include "flud.h"
+#include "umodes.h"
 
 #ifdef ANTI_DRONE_FLOOD
 #include "dbuf.h"
@@ -73,126 +74,11 @@
 int valid_username(const char* username);
 static void report_and_set_user_flags( aClient *, aConfItem * );
 static int tell_user_off(aClient *,char **);
-static void send_umode_out_oper (struct Client*, struct Client*, int,
+static void send_umode_out_oper (struct Client*, struct Client*, umode_t,
                                  struct Client*);
 int add_silence(struct Client *, char *);
 
-/* table of ascii char letters to corresponding bitmask */
-
-static FLAG_ITEM user_modes[] =
-{ 
-  {FLAGS_AUSPEX, 'a'},
-  {FLAGS_BOTS,  'b'},
-  {FLAGS_CCONN, 'c'},
-  {FLAGS_NCTCP, 'C'},
-  {FLAGS_DEBUG, 'd'},
-  {FLAGS_FULL,  'f'},
-  {FLAGS_INVISIBLE, 'i'},
-  {FLAGS_SKILL, 'k'},
-  {FLAGS_IMMUNE, 'm'},
-  {FLAGS_NCHANGE, 'n'},
-#ifdef CHANNEL_CREATION_NOTICE
-  {FLAGS_CHCREATE, 'l'},
-#endif
-  {FLAGS_NINVITE, 'I'},
-  {FLAGS_OPER, 'o'},
-  {FLAGS_LOCOP, 'O'},
-#ifdef GODOPERS
-  {FLAGS_GOD,   'p'},
-#endif
-  {FLAGS_REJ, 'r'},
-  {FLAGS_SERVNOTICE, 's'},
-  {FLAGS_WALLOP, 'w'},
-  {FLAGS_EXTERNAL, 'x'},
-  {FLAGS_SPY, 'y'},
-  {FLAGS_OPERWALL, 'z'},
-  {FLAGS_IDENTIFIED, 'e'},
-  {FLAGS_BLOCK_NOTID, 'E'},
-  {0, 0}
-};
-
-/* memory is cheap. map 0-255 to equivalent mode */
-
-static int user_modes_from_c_to_bitmask[] =
-{ 
-  /* 0x00 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0x0F */
-  /* 0x10 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0x1F */
-  /* 0x20 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0x2F */
-  /* 0x30 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0x3F */
-  0,            /* @ */
-  0,            /* A */
-  0,            /* B */
-  FLAGS_NCTCP,  /* C */
-  0,            /* D */
-  FLAGS_BLOCK_NOTID, /* E */
-  0,            /* F */
-  0,            /* G */
-  0,            /* H */
-  FLAGS_NINVITE, /* I */
-  0,            /* J */
-  0,            /* K */
-  0,            /* L */
-  0,            /* M */
-  0,            /* N */
-  FLAGS_LOCOP,  /* O */
-  0,            /* P */
-  0,            /* Q */
-  0,            /* R */
-  0,            /* S */
-  0,            /* T */
-  0,            /* U */
-  0,            /* V */
-  0,            /* W */
-  0,            /* X */
-  0,            /* Y */
-  0,            /* Z 0x5A */
-  0, 0, 0, 0, 0, /* 0x5F */ 
-  /* 0x60 */       0,
-  FLAGS_AUSPEX, /* a */
-  FLAGS_BOTS,   /* b */
-  FLAGS_CCONN,  /* c */
-  FLAGS_DEBUG,  /* d */
-  FLAGS_IDENTIFIED, /* e */
-  FLAGS_FULL,   /* f */
-  0,            /* g */
-  0,            /* h */
-  FLAGS_INVISIBLE, /* i */
-  0,            /* j */
-  FLAGS_SKILL,  /* k */
-#ifdef CHANNEL_CREATION_NOTICE
-  FLAGS_CHCREATE, /* l */
-#else
-  0,		/* l */
-#endif
-  FLAGS_IMMUNE, /* m */
-  FLAGS_NCHANGE, /* n */
-  FLAGS_OPER,   /* o */
-#ifdef GODOPERS
-  FLAGS_GOD,    /* p */
-#else
-  0,            /* p */
-#endif
-  0,            /* q */
-  FLAGS_REJ,    /* r */
-  FLAGS_SERVNOTICE, /* s */
-  0,            /* t */
-  0,            /* u */
-  0,            /* v */
-  FLAGS_WALLOP, /* w */
-  FLAGS_EXTERNAL, /* x */
-  FLAGS_SPY,    /* y */
-  FLAGS_OPERWALL, /* z 0x7A */
-  0,0,0,0,0,     /* 0x7B - 0x7F */
-
-  /* 0x80 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0x9F */
-  /* 0x90 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0x9F */
-  /* 0xA0 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0xAF */
-  /* 0xB0 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0xBF */
-  /* 0xC0 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0xCF */
-  /* 0xD0 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0xDF */
-  /* 0xE0 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 0xEF */
-  /* 0xF0 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0  /* 0xFF */
-};
+int user_modes_from_c_to_bitmask[256];
 
 /* internally defined functions */
 #ifdef BOTCHECK
@@ -226,13 +112,12 @@
   for(cptr2 = oper_cptr_list; cptr2; cptr2 = cptr2->next_oper_client)
     {
       ++j;
-      if (MyClient(cptr) && IsAnOper(cptr))
+      if (MyClient(cptr) && SeesOpers(cptr))
         {
           sendto_one(cptr, ":%s %d %s :[%c][%s] %s (%s@%s) Idle: %d",
                      me.name, RPL_STATSDEBUG, cptr->name,
-                     IsOper(cptr2) ? 'O' : 'o',
-                     oper_privs_as_string(cptr2,
-                                          cptr2->confs->value.aconf->port),
+                     IsLocOp(cptr2) ? 'o' : 'O',
+                     oper_flags_as_string(cptr2->confs->value.aconf->allowed_umodes),
                      cptr2->name,
                      cptr2->username, cptr2->host,
                      CurrentTime - cptr2->user->last);
@@ -241,7 +126,7 @@
         {
           sendto_one(cptr, ":%s %d %s :[%c] %s (%s@%s) Idle: %d",
                      me.name, RPL_STATSDEBUG, cptr->name,
-                     IsOper(cptr2) ? 'O' : 'o',
+                     IsLocOp(cptr2) ? 'o' : 'O',
                      cptr2->name,
                      cptr2->username, cptr2->host,
                      CurrentTime - cptr2->user->last);
@@ -269,7 +154,7 @@
 #endif
 
 /*  forced = (parc >= 2); */
-  forced = (IsAnOper(sptr) && (parc > 3));
+  forced = (CanForceLusers(sptr) && (parc > 3));
 
 /* (void)collapse(parv[1]); */
 
@@ -341,42 +226,42 @@
         {
           if (m_server != Count.myserver)
             {
-              sendto_realops_flags(FLAGS_DEBUG, 
-                                 "Local server count off by %d",
-                                 Count.myserver - m_server);
+              sendto_realops_flag(UMODE_DEBUG,
+                                  "Local server count off by %d ",
+				  Count.myserver - m_server);
               Count.myserver = m_server;
             }
           if (s_count != Count.server)
             {
-              sendto_realops_flags(FLAGS_DEBUG,
-                                 "Server count off by %d",
-                                 Count.server - s_count);
+              sendto_realops_flag(UMODE_DEBUG,
+				  "Server count off by %d",
+				  Count.server - s_count);
               Count.server = s_count;
             }
           if (i_count != Count.invisi)
             {
-              sendto_realops_flags(FLAGS_DEBUG,
-                                 "Invisible client count off by %d",
-                                 Count.invisi - i_count);
+              sendto_realops_flag(UMODE_DEBUG,
+				  "Invisible client count off by %d",
+				  Count.invisi - i_count);
               Count.invisi = i_count;
             }
           if ((c_count+i_count) != Count.total)
             {
-              sendto_realops_flags(FLAGS_DEBUG, "Total client count off by %d",
-                                 Count.total - (c_count+i_count));
+              sendto_realops_flag(UMODE_DEBUG, "Total client count off by %d",
+				  Count.total - (c_count+i_count));
               Count.total = c_count+i_count;
             }
           if (m_client != Count.local)
             {
-              sendto_realops_flags(FLAGS_DEBUG,
-                                 "Local client count off by %d",
-                                 Count.local - m_client);
+              sendto_realops_flag(UMODE_DEBUG,
+				  "Local client count off by %d",
+				  Count.local - m_client);
               Count.local = m_client;
             }
           if (o_count != Count.oper)
             {
-              sendto_realops_flags(FLAGS_DEBUG,
-                                 "Oper count off by %d", Count.oper - o_count);
+              sendto_realops_flag(UMODE_DEBUG,
+				  "Oper count off by %d", Count.oper - o_count);
               Count.oper = o_count;
             }
           Count.unknown = u_count;
@@ -392,7 +277,7 @@
 #endif
   
 #ifndef SHOW_INVISIBLE_LUSERS
-  if (IsAnOper(sptr) && i_count)
+  if (SeesAllConnections(sptr) && i_count)
 #endif
     sendto_one(sptr, form_str(RPL_LUSERCLIENT), me.name, parv[0],
                c_count, i_count, s_count);
@@ -596,10 +481,10 @@
 
         case I_LINE_FULL:
         case I_LINE_FULL2:
-          sendto_realops_flags(FLAGS_FULL, "%s for %s (%s).",
-                               "I-line is full",
-                               get_client_host(sptr),
-                               inetntoa((char*) &sptr->ip));
+          sendto_realops_flag(UMODE_FULL, "%s for %s (%s).",
+			      "I-line is full",
+			      get_client_host(sptr),
+			      inetntoa((char*) &sptr->ip));
           log(L_INFO,"Too many connections from %s.", get_client_host(sptr));
           ServerStats->is_ref++;
           return exit_client(cptr, sptr, &me, 
@@ -624,14 +509,14 @@
               ServerStats->is_ref++;
 	/* jdc - lists server name & port connections are on */
 	/*       a purely cosmetical change */
-              sendto_realops_flags(FLAGS_CCONN,
-				 "%s from %s [%s] on [%s/%u].",
-                                 "Unauthorized client connection",
-                                 get_client_host(sptr),
-                                 inetntoa((char *)&sptr->ip),
-				 sptr->listener->name,
-				 sptr->listener->port
-				 );
+              sendto_realops_flag(UMODE_CCONN,
+				  "%s from %s [%s] on [%s/%u].",
+				  "Unauthorized client connection",
+				  get_client_host(sptr),
+				  inetntoa((char *)&sptr->ip),
+				  sptr->listener->name,
+				  sptr->listener->port
+				  );
               log(L_INFO,
 		  "Unauthorized client connection from %s on [%s/%u].",
                   get_client_host(sptr),
@@ -741,7 +626,7 @@
           ((Count.local + 1) >= (MAXCLIENTS+MAX_BUFFER))) ||
             (((Count.local +1) >= (MAXCLIENTS - 5)) && !(IsFlined(sptr))))
         {
-          sendto_realops_flags(FLAGS_FULL,
+          sendto_realops_flag(UMODE_FULL,
                                "Too many clients, rejecting %s[%s].",
                                nick, sptr->host);
           ServerStats->is_ref++;
@@ -754,16 +639,16 @@
         {
           if(IsBlined(sptr))
             {
-              sendto_ops_flags_butone(NULL, FLAGS_BOTS,
-                                 "Possible %s: %s (%s@%s) [B-lined]",
-                                 type_of_bot[sptr->isbot],
-                                 sptr->name, sptr->username, sptr->host);
+              sendto_ops_flag_butone(NULL, UMODE_BOTS,
+				     "Possible %s: %s (%s@%s) [B-lined]",
+				     type_of_bot[sptr->isbot],
+				     sptr->name, sptr->username, sptr->host);
             }
           else
             {
-              sendto_realops_flags(FLAGS_BOTS, "Rejecting %s: %s",
-                                 type_of_bot[sptr->isbot],
-                                 get_client_name(sptr,FALSE));
+              sendto_realops_flag(UMODE_BOTS, "Rejecting %s: %s",
+				  type_of_bot[sptr->isbot],
+				  get_client_name(sptr,FALSE));
               ServerStats->is_ref++;
               return exit_client(cptr, sptr, sptr, type_of_bot[sptr->isbot] );
             }
@@ -775,15 +660,15 @@
 
       if (!valid_username(sptr->username))
         {
-          sendto_realops_flags(FLAGS_REJ,"Invalid username: %s (%s@%s)",
-                             nick, sptr->username, sptr->host);
+          sendto_realops_flag(UMODE_REJ,"Invalid username: %s (%s@%s)",
+			      nick, sptr->username, sptr->host);
           ServerStats->is_ref++;
           ircsprintf(tmpstr2, "Invalid username [%s]", sptr->username);
           return exit_client(cptr, sptr, &me, tmpstr2);
         }
       /* end of valid user name check */
 
-      if(!IsAnOper(sptr))
+      if(!CannotBeXlined(sptr))
         {
           char *reason;
 
@@ -798,29 +683,29 @@
                 {
                   if (aconf->port == 1)
                     {
-                      sendto_realops_flags(FLAGS_REJ,
-                                           "X-line Rejecting [%s] [%s], user %s",
-                                           sptr->info,
-                                           reason,
-                                           get_client_name(cptr, FALSE));
+                      sendto_realops_flag(UMODE_REJ,
+					  "X-line Rejecting [%s] [%s], user %s",
+					  sptr->info,
+					  reason,
+					  get_client_name(cptr, FALSE));
                     }
                   ServerStats->is_ref++;      
                   return exit_client(cptr, sptr, &me, "Bad user info");
                 }
               else
-                sendto_ops_flags_butone(NULL, FLAGS_REJ,
-                                   "X-line Warning [%s] [%s], user %s",
-                                   sptr->info,
-                                   reason,
-                                   get_client_name(cptr, FALSE));
+                sendto_ops_flag_butone(NULL, UMODE_REJ,
+				       "X-line Warning [%s] [%s], user %s",
+				       sptr->info,
+				       reason,
+				       get_client_name(cptr, FALSE));
             }
          }
 
-      sendto_ops_flags_butone(NULL, FLAGS_CCONN,
-                         "Client connecting: %s (%s@%s) [%s] {%d} [%s]",
-                         nick, sptr->username, sptr->host,
-                         inetntoa((char *)&sptr->ip),
-                         get_client_class(sptr), me.name);
+      sendto_ops_flag_butone(NULL, UMODE_CCONN,
+			     "Client connecting: %s (%s@%s) [%s] {%d} [%s]",
+			     nick, sptr->username, sptr->host,
+			     inetntoa((char *)&sptr->ip),
+			     get_client_class(sptr), me.name);
 
       if ((++Count.local) > Count.max_loc)
         {
@@ -848,18 +733,18 @@
   add_client_to_llist(&(sptr->servptr->serv->users), sptr);
 
   if (MyConnect(sptr) && (sptr->username[0] == '~' || isdigit(sptr->host[0])))
-    sendto_ops_flags_butone(NULL, FLAGS_CCONN,
-                            "Auth warning on %s (%s@%s) %s%s",
-                            sptr->name, sptr->username, sptr->host,
-                            (sptr->username[0] == '~') ? "[ident fail] " : "",
-                            (isdigit(sptr->host[0])) ? "[dns fail] " : "");
+    sendto_ops_flag_butone(NULL, UMODE_CCONN,
+			   "Auth warning on %s (%s@%s) %s%s",
+			   sptr->name, sptr->username, sptr->host,
+			   (sptr->username[0] == '~') ? "[ident fail] " : "",
+			   (isdigit(sptr->host[0])) ? "[dns fail] " : "");
 /* Increment our total user count here */
   if (++Count.total > Count.max_tot)
     {
       Count.max_tot = Count.total;
       if ( (!(Count.max_tot % 2)) && (record_time < CurrentTime - 30) )
         {
-          sendto_ops_flags(FLAGS_SERVNOTICE, "New network record: %d users (%d local)", Count.max_tot, Count.max_loc);
+          sendto_ops_flag(UMODE_SERVNOTICE, "New network record: %d users (%d local)", Count.max_tot, Count.max_loc);
           record_time = CurrentTime;
       }
     }
@@ -935,11 +820,11 @@
       aClient *acptr;
       if ((acptr = find_server(user->server)) && acptr->from != sptr->from)
         {
-          sendto_realops_flags(FLAGS_DEBUG, 
-                             "Bad User [%s] :%s USER %s@%s %s, != %s[%s]",
-                             cptr->name, nick, sptr->username,
-                             sptr->host, user->server,
-                             acptr->name, acptr->from->name);
+          sendto_realops_flag(UMODE_DEBUG, 
+			      "Bad User [%s] :%s USER %s@%s %s, != %s[%s]",
+			      cptr->name, nick, sptr->username,
+			      sptr->host, user->server,
+			      acptr->name, acptr->from->name);
           sendto_one(cptr,
                      ":%s KILL %s :%s (%s != %s[%s] USER from wrong direction)",
                      me.name, sptr->name, me.name, user->server,
@@ -968,7 +853,7 @@
         }
     }
 
-  send_umode(NULL, sptr, 0, SEND_UMODES, ubuf);
+  send_umode(NULL, sptr, 0, send_umodes, ubuf);
   if (!*ubuf)
     {
       ubuf[0] = '+';
@@ -1215,7 +1100,8 @@
                  char *parv[], time_t newts,char *nick)
 {
   Link* channels;
-  int setflags = sptr->umodes;
+  umode_t setflags;
+  CopyUmodes(setflags, sptr->umodes);
 
   if (IsServer(sptr))
     {
@@ -1247,15 +1133,16 @@
           while (*m)
             {
               flag = user_modes_from_c_to_bitmask[(unsigned char)*m];
-              if( flag & FLAGS_INVISIBLE )
+              if( flag == UMODE_INVISIBLE )
                 {
                   Count.invisi++;
                 }
-              if( flag & FLAGS_OPER )
+              if( flag == UMODE_OPER )
                 {
                   Count.oper++;
                 }
-              sptr->umodes |= flag & SEND_UMODES;
+	      if (TestBit(send_umodes, flag))
+		SetBit(sptr->umodes, flag);
               m++;
             }
           
@@ -1298,10 +1185,10 @@
           if(sptr->number_of_nick_changes <= MAX_NICK_CHANGES)
             {
 #endif
-              sendto_realops_flags(FLAGS_NCHANGE,
-                                 "Nick change: From %s to %s [%s@%s]",
-                                 parv[0], nick, sptr->username,
-                                 sptr->host);
+              sendto_realops_flag(UMODE_NCHANGE,
+				  "Nick change: From %s to %s [%s@%s]",
+				  parv[0], nick, sptr->username,
+				  sptr->host);
 
               ClearIdentifiedNick(sptr);
               send_umode_out(cptr, sptr, setflags);
@@ -1323,8 +1210,8 @@
                          me.name,
                          sptr->name,
                          MAX_NICK_TIME);
-              sendto_ops_flags_butone(NULL, FLAGS_BOTS, "Flooder %s [%s@%s] on %s (nick)",
-                                      sptr->name, sptr->username, sptr->host, me.name);
+              sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s (nick)",
+				     sptr->name, sptr->username, sptr->host, me.name);
 
               return 0;
             }
@@ -1340,16 +1227,17 @@
               add_history(sptr,1);
               sendto_serv_butone(cptr, ":%s NICK %s :%lu",
                                  parv[0], nick, sptr->tsinfo);
-              sendto_realops_flags(FLAGS_NCHANGE,
-                                 "Nick change: From %s to %s [%s@%s]",
-                                 parv[0], nick, sptr->username,
-                                 sptr->host);
+              sendto_realops_flag(UMODE_NCHANGE,
+				  "Nick change: From %s to %s [%s@%s]",
+				  parv[0], nick, sptr->username,
+				  sptr->host);
             }
         }
     }
   else
     {
       /* Client setting NICK the first time */
+      CopyUmodes(sptr->allowed_umodes, user_umodes);
       
 
       /* This had to be copied here to avoid problems.. */
@@ -1485,9 +1373,9 @@
       if (IsServer(cptr))
         {
           ServerStats->is_kill++;
-          sendto_realops_flags(FLAGS_DEBUG, "Bad Nick: %s From: %s %s",
-                             parv[1], parv[0],
-                             get_client_name(cptr, FALSE));
+          sendto_realops_flag(UMODE_DEBUG, "Bad Nick: %s From: %s %s",
+			      parv[1], parv[0],
+			      get_client_name(cptr, FALSE));
           sendto_one(cptr, ":%s KILL %s :%s (%s <- %s[%s])",
                      me.name, parv[1], me.name, parv[1],
                      nick, cptr->name);
@@ -1506,18 +1394,18 @@
             }
         }
       else
-        sendto_ops_flags_butone(NULL, FLAGS_BOTS, "Illegal nick \"%s\" from: %s %s",
-                                parv[1], parv[0],
-                                get_client_name(cptr, FALSE));
+        sendto_ops_flag_butone(NULL, UMODE_BOTS, "Illegal nick \"%s\" from: %s %s",
+			       parv[1], parv[0],
+			       get_client_name(cptr, FALSE));
       return 0;
     }
 
-  if(MyConnect(sptr) && !IsServer(sptr) && !IsAnOper(sptr) &&
+  if(MyConnect(sptr) && !IsServer(sptr) && !CannotBeQlined(sptr) &&
      find_q_line(nick, sptr->username, sptr->host)) 
     {
-      sendto_realops_flags(FLAGS_REJ,
-                         "Quarantined nick [%s] from user %s",
-                         nick,get_client_name(cptr, FALSE));
+      sendto_realops_flag(UMODE_REJ,
+			  "Quarantined nick [%s] from user %s",
+			  nick,get_client_name(cptr, FALSE));
       sendto_one(sptr, form_str(ERR_ERRONEUSNICKNAME),
                  me.name, parv[0], parv[1]);
       return 0;
@@ -2053,15 +1941,7 @@
       sptr->flags |= FLAGS_INVISIBLE;
 #endif
 
-#if 0
-      /* Undocumented lame extension to the protocol
-       * if user provides a number, the bits set are
-       * used to set the umode flags. arghhhhh -db
-       */
-      sptr->flags |= (UFLAGS & atoi(host));
-#endif
-
-      if (!(oflags & FLAGS_INVISIBLE) && IsInvisible(sptr))
+      if (IsInvisible(sptr))
         Count.invisi++;
       /*
        * don't take the clients word for it, ever
@@ -2100,11 +1980,12 @@
   int   i;
   char  **p, *m;
   aClient *acptr;
-  int   what, setflags;
+  int   what;
   char  *m2;
   int   ircophack, restrictedmodes;
   int   badflag = NO;   /* Only send one bad flag notice -Dianora */
   char  buf[BUFSIZE];
+  umode_t bad_umodes, old_umodes;
 
   what = MODE_ADD;
   ircophack = 0;
@@ -2127,7 +2008,7 @@
 
   if (IsServer(sptr) || sptr != acptr || acptr->from != sptr->from)
     {
-      if (sptr != acptr && IsGodOper(sptr))
+      if (sptr != acptr && CanChangeModes(sptr))
         {
           ircophack = 1;
           
@@ -2138,31 +2019,50 @@
                 for (p = &parv[2]; p && *p; p++ )
                   {
                     for (m = *p, m2 = *p; *m; m++)
-                      switch(user_modes_from_c_to_bitmask[(unsigned char)*m])
-                        {
-			  case FLAGS_NCHANGE:
-                            if (IsSetOperN(sptr))
-                              *(m2++) = *m;
-                            break;
-                          case FLAGS_IMMUNE:
-                            if (IsSetOperM(sptr))
-                              *(m2++) = *m;
-                            break;
-#ifdef GODOPERS
-			  case FLAGS_GOD:
-			    if (IsSetOperGod(sptr))
-			      *(m2++) = *m;
-			    break;
-#endif
-			  case FLAGS_AUSPEX:
-                            if (IsSetOperAuspex(sptr))
-                              *(m2++) = *m;
-                            break;
-                          default:
-                            *(m2++) = *m;
-                            break;
-                        }
-                    *m2 = 0;
+		      switch(*m)
+			{
+			case '+':
+			  what = MODE_ADD;
+			  break;
+			case '-' :
+			  what = MODE_DEL;
+			  break;
+			default:
+			  if (CanGrantModes(sptr))
+			    {
+			      if ((what == MODE_ADD)
+				  && TestBit(sptr->allowed_umodes, user_modes_from_c_to_bitmask[(unsigned char)*m]))
+				{
+				  *(m2++) = *m; /* remove the umodes the originators's O:line doesn't allow them to have */
+				  /* But add them to the target's allowed umodes */
+				  SetBit(acptr->allowed_umodes, user_modes_from_c_to_bitmask[(unsigned char)*m]);
+				}
+			      else if ((what == MODE_DEL) && !IsAnOper(acptr))
+				{
+				  /* If they are not an operator, remove that umode from their allowed_umodes 
+				   *  if it is not in user_umodes
+				   */
+				  if (!TestBit(user_umodes, user_modes_from_c_to_bitmask[(unsigned char)*m]))
+				    ClearBit(acptr->allowed_umodes, user_modes_from_c_to_bitmask[(unsigned char)*m]);
+				}
+			    }
+			  else
+			    {
+			      if ((what == MODE_ADD) &&
+				  TestBit(acptr->allowed_umodes, user_modes_from_c_to_bitmask[(unsigned char)*m]))
+				*(m2++) = *m; /* remove the umodes the target's O:line doesn't allow them to have */
+			      else if ((what == MODE_DEL) && !IsAnOper(acptr))
+				{
+				  /* If they are not an operator, remove that umode from their allowed_umodes 
+				   *  if it is not in user_umodes
+				   */
+				  if (!TestBit(user_umodes, user_modes_from_c_to_bitmask[(unsigned char)*m]))
+				    ClearBit(acptr->allowed_umodes, user_modes_from_c_to_bitmask[(unsigned char)*m]);
+				}
+			    }
+			  break;
+			}
+		    *m2 = 0;
                   }
               sendto_one(acptr->from, ":%s MODE %s %s", sptr->name,
                          acptr->name, ((parc < 3) ? "" : parv[2]));
@@ -2170,10 +2070,10 @@
             }
         }
       else if (IsServer(cptr))
-        sendto_ops_butone(NULL, &me,
-                          ":%s WALLOPS :MODE for User %s From %s!%s",
-                          me.name, parv[1],
-                          get_client_name(cptr, FALSE), sptr->name);
+        sendto_ops_flag_butone(NULL, UMODE_SERVNOTICE,
+			       "%s issuing MODE for User %s From %s!%s",
+			       me.name, parv[1],
+			       get_client_name(cptr, FALSE), sptr->name);
       else
         sendto_one(sptr, form_str(ERR_USERSDONTMATCH),
                    me.name, parv[0]);
@@ -2181,14 +2081,14 @@
       if (!ircophack)
         return 0;
     }
- 
+
   if (parc < 3)
     {
       m = buf;
       *m++ = '+';
 
       for (i = 0; user_modes[i].letter && (m - buf < BUFSIZE - 4);i++)
-        if (acptr->umodes & user_modes[i].mode)
+        if (TestBit(acptr->umodes, user_modes[i].mode))
           *m++ = user_modes[i].letter;
       *m = '\0';
 
